package dev.shadowsoffire.apotheosis.advancements;

package .tmp;

import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.advancements.ModifierTrigger;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance;
import net.minecraft.advancements.critereon.ContextAwarePredicate;
import net.minecraft.advancements.critereon.MinMaxBounds;
import net.minecraft.advancements.critereon.SerializationContext;

public class Instance extends AbstractCriterionTriggerInstance {
  private final MinMaxBounds.Ints minDelay;
  
  private final MinMaxBounds.Ints maxDelay;
  
  private final MinMaxBounds.Ints spawnCount;
  
  private final MinMaxBounds.Ints nearbyEnts;
  
  private final MinMaxBounds.Ints playerRange;
  
  private final MinMaxBounds.Ints spawnRange;
  
  private final Boolean ignorePlayers;
  
  private final Boolean ignoreConditions;
  
  private final Boolean redstone;
  
  private final Boolean ignoreLight;
  
  private final Boolean noAI;
  
  public Instance(MinMaxBounds.Ints minDelay, MinMaxBounds.Ints maxDelay, MinMaxBounds.Ints spawnCount, MinMaxBounds.Ints nearbyEnts, MinMaxBounds.Ints playerRange, MinMaxBounds.Ints spawnRange, Boolean ignorePlayers, Boolean ignoreConditions, Boolean redstone, Boolean ignoreLight, Boolean noAI) {
    super(ModifierTrigger.ID, ContextAwarePredicate.f_285567_);
    this.minDelay = minDelay;
    this.maxDelay = maxDelay;
    this.spawnCount = spawnCount;
    this.nearbyEnts = nearbyEnts;
    this.playerRange = playerRange;
    this.spawnRange = spawnRange;
    this.ignorePlayers = ignorePlayers;
    this.ignoreConditions = ignoreConditions;
    this.redstone = redstone;
    this.ignoreLight = ignoreLight;
    this.noAI = noAI;
  }
  
  public JsonObject m_7683_(SerializationContext serializer) {
    return new JsonObject();
  }
  
  public boolean test(ApothSpawnerTile tile, SpawnerModifier modif) {
    ApothSpawnerTile.SpawnerLogicExt logic = (ApothSpawnerTile.SpawnerLogicExt)tile.f_59788_;
    if (!this.minDelay.m_55390_(logic.f_45447_) || !this.maxDelay.m_55390_(logic.f_45448_) || !this.spawnCount.m_55390_(logic.f_45449_) || !this.nearbyEnts.m_55390_(logic.f_45451_))
      return false; 
    if (!this.playerRange.m_55390_(logic.f_45452_))
      return false; 
    if (!this.spawnRange.m_55390_(logic.f_45453_))
      return false; 
    if (this.ignorePlayers != null && tile.ignoresPlayers != this.ignorePlayers.booleanValue())
      return false; 
    if (this.ignoreConditions != null && tile.ignoresConditions != this.ignoreConditions.booleanValue())
      return false; 
    if (this.redstone != null && tile.redstoneControl != this.redstone.booleanValue())
      return false; 
    if (this.ignoreLight != null && tile.ignoresLight != this.ignoreLight.booleanValue())
      return false; 
    if (this.noAI != null && tile.hasNoAI != this.noAI.booleanValue())
      return false; 
    return true;
  }
}
